# API Reference

```@meta
CurrentModule = FunSQL
```

```@autodocs
Modules = [FunSQL]
Pages = ["FunSQL.jl"]
```


## SQL Dialects

```@autodocs
Modules = [FunSQL]
Pages = ["dialects.jl"]
```

## SQL Entities

```@autodocs
Modules = [FunSQL]
Pages = ["entities.jl"]
```


## SQL Statements

```@autodocs
Modules = [FunSQL]
Pages = ["statements.jl"]
```


## Semantic Structure

```@autodocs
Modules = [FunSQL]
Pages = [
    "nodes.jl",
    "nodes/aggregate.jl",
    "nodes/append.jl",
    "nodes/as.jl",
    "nodes/bind.jl",
    "nodes/define.jl",
    "nodes/from.jl",
    "nodes/function.jl",
    "nodes/get.jl",
    "nodes/group.jl",
    "nodes/highlight.jl",
    "nodes/iterate.jl",
    "nodes/join.jl",
    "nodes/limit.jl",
    "nodes/literal.jl",
    "nodes/order.jl",
    "nodes/partition.jl",
    "nodes/select.jl",
    "nodes/sort.jl",
    "nodes/variable.jl",
    "nodes/where.jl",
    "nodes/with.jl",
    "nodes/with_external.jl",
]
```


## Syntactic Structure

```@autodocs
Modules = [FunSQL]
Pages = [
    "clauses.jl",
    "clauses/aggregate.jl",
    "clauses/as.jl",
    "clauses/case.jl",
    "clauses/from.jl",
    "clauses/function.jl",
    "clauses/group.jl",
    "clauses/having.jl",
    "clauses/identifier.jl",
    "clauses/join.jl",
    "clauses/keyword.jl",
    "clauses/limit.jl",
    "clauses/literal.jl",
    "clauses/note.jl",
    "clauses/operator.jl",
    "clauses/order.jl",
    "clauses/partition.jl",
    "clauses/select.jl",
    "clauses/sort.jl",
    "clauses/union.jl",
    "clauses/variable.jl",
    "clauses/where.jl",
    "clauses/window.jl",
    "clauses/with.jl",
]
```

